﻿Option Explicit On
Option Strict On

Public Class Form1
    Public Client As Net.Sockets.UdpClient
    Public RemoteIpEndPoint As New System.Net.IPEndPoint(System.Net.IPAddress.Any, 0) 'any ip we dont care
    Public ThreadReceive As System.Threading.Thread
    Delegate Sub SetTextCallback([text] As String)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'Create UDP Client
        Client = New System.Net.Sockets.UdpClient(4123) 'port
        'Start a Treaded Recieve
        ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
        ThreadReceive.IsBackground = True
        ThreadReceive.Start()
    End Sub


    Public Sub ReceiveMessages()
        'Get String
        Dim receiveBytes As [Byte]() = Client.Receive(RemoteIpEndPoint)
        Dim BitDet As BitArray = New BitArray(receiveBytes)
        Dim strReturnData As String = System.Text.Encoding.ASCII.GetString(receiveBytes)

        'safe call to another thread to set text "strReturnData"
        Dim d As New SetTextCallback(AddressOf SetText)
        Me.Invoke(d, New Object() {strReturnData})

        'Start new Treaded Recieve
        ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
        ThreadReceive.IsBackground = True
        ThreadReceive.Start()
    End Sub

    Private Sub SetText(ByVal Value As String)
        'See if we have good data and extract it
        If Value.Contains("S:") = True And Value.Contains(":E") = True Then
            Dim split() As String = Value.Split(CType(":", Char())) 'split string
            If split.Count >= 4 Then 'see if we have at least 4 pieses of data
                txt_Roll.Text = split(1) 'set roll
                txt_Pitch.Text = split(2) 'set pitch
            End If
        End If
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        On Error Resume Next
        ThreadReceive.Abort()
        Client.Close()
    End Sub
End Class
